% crafting signals for roulette 
DAYS = 50 * 365; % 50 years of roulette playing ... 
GAMESADAY = 1000; 
roul = floor(rand(DAYS, GAMESADAY) * 37); 

% make the results false - make 32 following 3 after 3 samples more frequent  with .5 probability... 
N1 = 32; N2 = 3; delay = 3; proba = 0.1
for ii=1:DAYS, 
  x = roul(ii,:); 
  % find occurrences of N1 ...
  n1occs = find (x == N1); 
  % find occurrences of N2 ... 
  n2occs = find (x == N2);
  % find places that are 'delay' samples after the occurrences of N1
  placestohit = n1occs + delay; 
  % discard places that are beyond ... 
  placestohit = placestohit(find(placestohit <= GAMESADAY)) ;
  % ... and apply the correct probability
  placestohit = placestohit(find(rand(size(placestohit)) < proba)); 
  % select appropriate N2 numbers (shiffle first) 
  n2occs = n2occs(randperm(length(n2occs))) ;
  % chosse the smallest dimension and limit our indices 
  targetdim = min([length(n2occs)  length(placestohit)]);
  placestohit = placestohit(1:targetdim) ;
  n2occs = n2occs(1:targetdim);
  % OK, run the changing ... 
  aux = x(placestohit); x(placestohit) = x(n2occs); x(n2occs) = aux; 
  % place it back 
  roul(ii,:) = x; %pause; 
end

% some checks ... 
plot (mean(roul))
plot (std(roul))
% ... both ok, now some 2-dim stuff ... 
H = hist3 (roul(:,[10 10]),[37 37]); imagesc(0:36,0:36, H); colorbar; axis image; 
H = hist3 (roul(:,[10 11]),[37 37]); imagesc(0:36,0:36, H); colorbar; axis image; 
H = hist3 (roul(:,[10 13]),[37 37]); imagesc(0:36,0:36, H); colorbar; axis image; 
H = hist3 (roul(:,[10 20]),[37 37]); imagesc(0:36,0:36, H); colorbar; axis image; 
% ... everything nice. Save it. 
%save -ascii roulette.txt roul % too bad, 282 meg file ... 
ff = fopen ('roulette.bin','wb'); 
fwrite(ff,roul,'uchar'); 
fclose (ff); % 18 mega, OK. 

% check that we can load it ... 
clear all 
DAYS = 50 * 365; % 50 years of roulette playing ... 
GAMESADAY = 1000; 
ff = fopen ('roulette.bin','rb'); 
ksid = fread(ff,[DAYS GAMESADAY],'uchar'); 
fclose (ff); 
H = hist3 (ksid(:,[10 13]),[37 37]); imagesc(0:36,0:36, H); colorbar; axis image; 
% looks OK. INspection in MC - OK. 

% --------------- load and show data -------------------------
% --- discrete one - roulette 
clear all 
OMEGAd = 50 * 365; % 50 years of roulette playing ... 
Nd = 1000; % games a day ... 
ff = fopen ('../sig/roulette.bin','rb'); 
ksid = fread(ff,[OMEGAd Nd],'uchar'); 
fclose (ff); 

ksid(1:15,1:20)
  30    34    10    14    29    35     6    35    33    30    35    30     9    11    11    13    17    22    33    21
    33    23    35     0    15    15    17     8    12    23    24    24    26    12    16    21     9     7    14    18
     4     4    13    28    15     9    19    29    25    35    22    36    12    34     4    17    31     7    35    15
    33    34     6     3     8    29     5     2    10    26    12    32    28    31    36    26    36     5    34    35
    23    17    21    28    16    28     1     2     9    36     7     3     3    36    34    28    18    33    14     3
     3    34    18    29    12    26     9    23     3    12     9    15    17     0    34     1     6    35    28    24
    10    36     9    17    25    30    16     9     2    10    10     9    11    17    10    25    23    23    24    25
    20    10    34    12     5     8    20    10    26     9    23     2     7     4     1    30    22    13     4    15
    35    19    17    27    14     2     9     4     8    24    16    14    13    13    32    21    27    30     5    33
    35     0    33     4     0    33    20    10     1     9    12     0    34    32     1    18     0    11    12    35
     5     5     4    13    27     4     3    33    29    13    20    15    19     6    29    12    22     3    30     4
    35    13    11    30    16    28     0     1     1     4    22    27    21    17    11    28    15     8    18    28
    35    28    15    35    15    35     4     5    17    36    17    30     1    32    27    26    13    17     3    22
    17    11    14    15    12    33     5    31    15    28    12    35     8    22    33     3     0    25    33    31
    29    20    35    19    14    26     1    31    23    14     1     2    33    17     2     0    14    24    28    13

% --- continuous one - water  'c' is contionuous 
s = wavread('sig/voda.wav'); 
% ramce 20 ms, jsme na 16k, takze 320. 
ksic = trame(s,320,0)'; % POZOR !!! CHCI JEDNOTLIVA MERENI V RADCICH ! 
[OMEGAc,Nc] = size(ksic);   
% a few pictures for slides: 
nc = 0:(Nc-1); 
om = 1; subplot(411); plot(nc,ksic(om,:)); title(['\omega=' num2str(om)]);grid; axis tight; 
om = 2; subplot(412); plot(nc,ksic(om,:)); title(['\omega=' num2str(om)]);grid; axis tight; 
om = 500; subplot(413); plot(nc,ksic(om,:)); title(['\omega=' num2str(om)]);grid; axis tight; 
om = 1000; subplot(414); plot(nc,ksic(om,:)); title(['\omega=' num2str(om)]);grid; axis tight; 
print -dpng fig/waters.png

%---------- disrtib fce - vse pro 10. vzorek ...  -----------------
% --- ruleta 
n = 10; 
x = -5:0.05:40; 
close all; 
h = hist(ksid(:,n),x); %bar(x,h); 
p = h / OMEGAd; F = cumsum(p); 
plot (x,F); xlabel('x'); ylabel('F(x,n)'); grid; axis tight; 
print -dpng fig/F_roul.png

% --- voda 
n = 10; 
x = -0.7:0.01:0.7; 
close all; 
h = hist(ksic(:,n),x); %bar(x,h); 
p = h / OMEGAc; F = cumsum(p); 
plot (x,F); xlabel('x'); ylabel('F(x,n)'); grid; axis tight; 
print -dpng fig/F_water.png
    
% ---------- pravdepodobnosti -------------
% disk  
n = 10; 
x = 0:36; Px = zeros(size(x)); data = ksid(:,n); 
for ii=1:37,
  Px(ii) = sum(data == x(ii)); 
end
Px = Px / OMEGAd; sum(Px) % check 
stem (x,Px); xlabel('X_i'); ylabel('P(X_i,n)'); grid; axis tight; 
print -dpng fig/P_roul.png

% spoj - proba dist function here ... pomoci derivace ... plotit oboji ! 
n = 10; 
x = -0.7:0.05:0.7; % needs less resolution, otherwise p(x) shitty ... 
close all; 
h = hist(ksic(:,n),x); %bar(x,h); 
p = h / OMEGAc; F = cumsum(p); 
p = diff(F); 
plotyy(x,F,x(1:end-1),p); xlabel('x'); title('F(x,n),  p(x,n)'); grid;axis tight;  
print -dpng fig/p_water.png

% odhad p(x,n) primo - siroke chlivky, at jsou videt ! 
x = -0.5:0.05:0.5; 
close all; 
h = hist(ksic(:,n),x); bar(x,h,1); axis tight; xlabel('x'); grid; 
print -dpng fig/hist_water.png
P = h / OMEGAc; 
bar(x,P,1); axis tight; xlabel('x'); grid; 
print -dpng fig/proba_water.png
p = h / OMEGAc / 0.05; 
bar(x,p,1); axis tight; xlabel('x'); grid; 
print -dpng fig/probadist_water.png

%------------------- 2d things ---------------------------
n1=10; n2=11; 
data1 = ksid(:,n1); data2 = ksid(:,n2);
X1 = 0:36; X2 = 0:36; 
Pxx = zeros(37,37); 
for ii=1:37
  for jj=1:37 
    Pxx(ii,jj) = sum((data1 == X1(ii)) & (data2 == X2(jj))); % this is the waiter with bill...
  end
end
Pxx = Pxx / OMEGAd; 
bar3(X1,Pxx); colormap([0 0 0.95]); axis tight;   % setting cmap to just one color ... 
print -dpng fig/2d_roul_10_11_bars.png

% better in images and will use hist3 ... DO NOT USE IMAGE STYLE AXIS !!!!! 
n1=10; n2=11; 
close all 
H = hist3 (ksid(:,[n1 n2]),[37 37]); imagesc(0:36,0:36, H / OMEGAd); colorbar; axis xy; 
print -dpng fig/2d_roul_10_11.png

% ok, other combinations of samples ... will use hist3 ... 
n1=10; n2=13; 
H = hist3 (ksid(:,[n1 n2]),[37 37]); imagesc(0:36,0:36, H / OMEGAd); colorbar; axis xy; 
print -dpng fig/2d_roul_10_13.png

n1=10; n2=10; 
H = hist3 (ksid(:,[n1 n2]),[37 37]); imagesc(0:36,0:36, H / OMEGAd); colorbar; axis xy; 
print -dpng fig/2d_roul_10_10.png

% ----- 2d spojity ... 
x1 = linspace(-0.4,0.4,30); x2 = x1; delta = x1(2) - x1(1) 
n1 = 10; n2 = 11; H = hist3(ksic(:,[n1 n2]),{x1 x2}); 
imagesc(x1,x2, H ); colorbar; axis xy; 
print -dpng fig/2d_water_hist_10_11.png

P = H / OMEGAc; 
imagesc(x1,x2, P); colorbar; axis xy; 
print -dpng fig/2d_water_proba_10_11.png

p = H / OMEGAc / delta / delta; 
imagesc(x1,x2, p); colorbar; axis xy; 
print -dpng fig/2d_water_pdf_10_11.png

% some other pairs of n1 and n2 ... 
n1 = 10; n2 = 16; H = hist3(ksic(:,[n1 n2]),{x1 x2}); 
p = H / OMEGAc / delta / delta; 
imagesc(x1,x2, p); colorbar; axis xy; 
print -dpng fig/2d_water_pdf_10_16.png

n1 = 10; n2 = 23; H = hist3(ksic(:,[n1 n2]),{x1 x2}); 
p = H / OMEGAc / delta / delta; 
imagesc(x1,x2, p); colorbar; axis xy; 
print -dpng fig/2d_water_pdf_10_23.png

n1 = 10; n2 = 10; H = hist3(ksic(:,[n1 n2]),{x1 x2}); 
p = H / OMEGAc / delta / delta; 
imagesc(x1,x2, p); colorbar; axis xy; 
print -dpng fig/2d_water_pdf_10_10.png

%--------------------- momenty --------------------
% discrete mean with PDF 
n1 = 10; X = 0:36; 
h = hist(ksid(:,n1),X); P = h / OMEGAd; sum(P) %check
subplot(221); stem(X,P); title('P(X_i,n)'); grid; axis tight; 
subplot(223); stem(X,X); title('X_i'); grid; axis tight;
subplot(222); stem(X,P.*X); title('X_i P(X_i,n)'); grid; axis tight;
print -dpng fig/mean_roul.png

sum(P.*X) 
   18.0422

% cont mean with PDF 
n1 = 10; x = linspace(-0.4,0.4,30); delta = x(2) - x(1) 
h = hist(ksic(:,n1),x); p = h / OMEGAc / delta; sum(p) * delta %check
subplot(221); plot(x,p); title('p(x,n)'); grid; axis tight; 
subplot(223); plot(x,x); title('x'); grid; axis tight;
subplot(222); plot(x,p.*x); title('x p(x,n)'); grid; axis tight;
print -dpng fig/mean_water.png
sum(p.*x) * delta 
   -0.0073

% discrete variance 
n1 = 10; X = 0:36; 
h = hist(ksid(:,n1),X); P = h / OMEGAd; sum(P) %check
a = sum(P.*X) 
subplot(221); stem(X,P); title('P(X_i,n)'); grid; axis tight; 
subplot(223); stem(X,X); title('X_i'); grid; axis tight;
subplot(222); stem(X,(X-a).^2); title('(X_i-a[n])^2'); grid; axis tight;
out = P .* ((X-a).^2); 
subplot(224); stem(X,out); title('(X_i-a[n])^2 P(X_i,n)'); grid; axis tight;
print -dpng fig/var_roul.png
sum(out)
  113.8563

% cont variance 
n1 = 10; x = linspace(-0.4,0.4,30); delta = x(2) - x(1) 
h = hist(ksic(:,n1),x); p = h / OMEGAc / delta; sum(p) * delta %check
a=sum(p.*x) * delta 
subplot(221); plot(x,p); title('p(x,n)'); grid; axis tight; 
subplot(223); plot(x,x); title('x'); grid; axis tight;
subplot(222); plot(x,(x-a).^2); title('(x-a[n])^2'); grid; axis tight;
out = p .* ((x-a).^2); 
subplot(224); plot(x,out); title('(x-a[n])^2 p(x,n)'); grid; axis tight;
print -dpng fig/var_water.png
sum(out) * delta 
       0.0183

% ensemble estimates - use unbiased one var(gg,1)
% discrete 
n = 10; mean(ksid(:,n))
var(ksid(:,n) , 1)
   18.0422
  113.8563 ... exactly the same as P(X_i estim is perfect) 
  
n = 10; mean(ksic(:,n))
var(ksic(:,n) , 1)
   -0.0069   ... this one is a bit different ... 
     0.0183
 
% -------------- corr coeffs -----------------------
% my hacked colormpas will be needed ... 
% show probas or proba distribs as grayscale. 
close all; 
X1 = 0:36; X2 = 0:36; 
n1=10; n2=11; 
H = hist3 (ksid(:,[n1 n2]),{X1 X2}); P = H / OMEGAd; sum(sum(P))
subplot(221); imagesc(X1, X2, P); colormap(gray);colorbar; title('P(X_1,X_2,n_1,n_2)');axis xy; 
X1X2 = X1' * X2; 
subplot(222); imagesc(X1, X2, X1X2); colormap(gray);colorbar; title('X_1 X_2'); axis xy; 
PX1X2 = P .* X1X2; 
subplot(223); imagesc(X1, X2, PX1X2); colormap(gray);colorbar; title('X_1 X_2 P(X_1,X_2,n_1,n_2)'); axis xy; 
print -dpng fig/korel_roul_10_11.png

sum(sum(PX1X2)) 
  324.2020

% 10 13 
n1=10; n2=13; 
H = hist3 (ksid(:,[n1 n2]),{X1 X2}); P = H / OMEGAd; sum(sum(P))
subplot(221); imagesc(X1, X2, P); colormap(gray);colorbar; title('P(X_1,X_2,n_1,n_2)');axis xy; 
X1X2 = X1' * X2; 
subplot(222); imagesc(X1, X2, X1X2); colormap(gray);colorbar; title('X_1 X_2'); axis xy; 
PX1X2 = P .* X1X2; 
subplot(223); imagesc(X1, X2, PX1X2); colormap(gray);colorbar; title('X_1 X_2 P(X_1,X_2,n_1,n_2)'); axis xy; 
print -dpng fig/korel_roul_10_13.png

sum(sum(PX1X2)) 
  326.9284

% 10 10
n1=10; n2=10; 
H = hist3 (ksid(:,[n1 n2]),{X1 X2}); P = H / OMEGAd; sum(sum(P))
subplot(221); imagesc(X1, X2, P); colormap(gray);colorbar; title('P(X_1,X_2,n_1,n_2)');axis xy; 
X1X2 = X1' * X2; 
subplot(222); imagesc(X1, X2, X1X2); colormap(gray);colorbar; title('X_1 X_2'); axis xy; 
PX1X2 = P .* X1X2; 
subplot(223); imagesc(X1, X2, PX1X2); colormap(gray);colorbar; title('X_1 X_2 P(X_1,X_2,n_1,n_2)'); axis xy; 
print -dpng fig/korel_roul_10_10.png

sum(sum(PX1X2)) 
  439.3770

%--- continuous - needs this special colormap ... 
BLUERED = zeros(101,3); % red  / green / blue
gg = linspace(0,1,51)';
BLUERED(51:101,1) = gg; % red one
BLUERED(51:-1:1,3) = gg; % blue one

x1 = linspace(-0.4,0.4,30); x2 = x1; delta = x1(2) - x1(1);  

% 10 11 
n1 = 10; n2 = 11; H = hist3(ksic(:,[n1 n2]),{x1 x2}); p = H / OMEGAc / delta / delta; sum(sum(p)) * delta * delta 
subplot(221); imagesc(x1,x2, H ); colormap(gray); colorbar; title('p(x_1,x_2,n_1,n_2)');axis xy; freezeColors; cbfreeze; 
x1x2 = x1' * x2; 
subplot(222); image(x1,x2,x1x2,'CDataMapping','scaled'); caxis([-0.15 0.15]); colormap(BLUERED); colorbar; title('x_1 x_2'); axis xy; 
px1x2 = p.*x1x2; 
subplot(223); image(x1,x2,px1x2,'CDataMapping','scaled'); caxis([-0.47 0.47]); colormap(BLUERED); colorbar; title('x_1 x_2 p(x_1,x_2,n_1,n_2)'); axis xy; 
print -dpng fig/korel_water_10_11.png
sum(sum(px1x2 * delta * delta)) 
    0.0159

% 10 16
n1 = 10; n2 = 16; H = hist3(ksic(:,[n1 n2]),{x1 x2}); p = H / OMEGAc / delta / delta; sum(sum(p)) * delta * delta 
subplot(221); imagesc(x1,x2, H ); colormap(gray); colorbar; title('p(x_1,x_2,n_1,n_2)');axis xy; freezeColors; cbfreeze; 
x1x2 = x1' * x2; 
subplot(222); image(x1,x2,x1x2,'CDataMapping','scaled'); caxis([-0.15 0.15]); colormap(BLUERED); colorbar; title('x_1 x_2'); axis xy; 
px1x2 = p.*x1x2; 
subplot(223); image(x1,x2,px1x2,'CDataMapping','scaled'); caxis([-0.21 0.21]); colormap(BLUERED); colorbar; title('x_1 x_2 p(x_1,x_2,n_1,n_2)'); axis xy; 
print -dpng fig/korel_water_10_16.png
sum(sum(px1x2 * delta * delta)) 
   3.8406e-04

% 10 23
n1 = 10; n2 = 23; H = hist3(ksic(:,[n1 n2]),{x1 x2}); p = H / OMEGAc / delta / delta; sum(sum(p)) * delta * delta 
subplot(221); imagesc(x1,x2, H ); colormap(gray); colorbar; title('p(x_1,x_2,n_1,n_2)');axis xy; freezeColors; cbfreeze; 
x1x2 = x1' * x2; 
subplot(222); image(x1,x2,x1x2,'CDataMapping','scaled'); caxis([-0.15 0.15]); colormap(BLUERED); colorbar; title('x_1 x_2'); axis xy; 
px1x2 = p.*x1x2; 
subplot(223); image(x1,x2,px1x2,'CDataMapping','scaled'); caxis([-0.38 0.38]); colormap(BLUERED); colorbar; title('x_1 x_2 p(x_1,x_2,n_1,n_2)'); axis xy; 
print -dpng fig/korel_water_10_23.png
sum(sum(px1x2 * delta * delta)) 
   -0.0139

% 10 10
n1 = 10; n2 = 10; H = hist3(ksic(:,[n1 n2]),{x1 x2}); p = H / OMEGAc / delta / delta; sum(sum(p)) * delta * delta 
subplot(221); imagesc(x1,x2, H ); colormap(gray); colorbar; title('p(x_1,x_2,n_1,n_2)');axis xy; freezeColors; cbfreeze; 
x1x2 = x1' * x2; 
subplot(222); image(x1,x2,x1x2,'CDataMapping','scaled'); caxis([-0.15 0.15]); colormap(BLUERED); colorbar; title('x_1 x_2'); axis xy; 
px1x2 = p.*x1x2; 
subplot(223); image(x1,x2,px1x2,'CDataMapping','scaled'); caxis([-1.7 1.7]); colormap(BLUERED); colorbar; title('x_1 x_2 p(x_1,x_2,n_1,n_2)'); axis xy; 
print -dpng fig/korel_water_10_10.png
sum(sum(px1x2 * delta * delta)) 
    0.0184
    
%%%%%%% direct ensemble estimates of correl - wow, never done it ... 
% discrete 
n1 =10; n2 = 10;  data1 = ksid(:,n1); data2 = ksid(:,n2); 
R = sum(data1 .* data2) / OMEGAd 
  439.3770
n1 =10; n2 = 11;  data1 = ksid(:,n1); data2 = ksid(:,n2); 
R = sum(data1 .* data2) / OMEGAd 
  324.2020

n1 =10; n2 = 13;  data1 = ksid(:,n1); data2 = ksid(:,n2); 
R = sum(data1 .* data2) / OMEGAd 
  326.9284

% cont 
n1 =10; n2 = 10;  data1 = ksic(:,n1); data2 = ksic(:,n2); 
R = sum(data1 .* data2) / OMEGAc
    0.0183
n1 =10; n2 = 11;  data1 = ksic(:,n1); data2 = ksic(:,n2); 
R = sum(data1 .* data2) / OMEGAc
    0.0160
n1 =10; n2 = 16;  data1 = ksic(:,n1); data2 = ksic(:,n2); 
R = sum(data1 .* data2) / OMEGAc
   3.8000e-04
n1 =10; n2 = 23;  data1 = ksic(:,n1); data2 = ksic(:,n2); 
R = sum(data1 .* data2) / OMEGAc
   -0.0140

% ... looks good. 

%%%%%%%%% tracing some sequences of Rk's ... 
% disc
n1 =10; R = zeros(1,21); 
for ii=0:20,
  n2=n1+ii;  data1 = ksid(:,n1); data2 = ksid(:,n2); 
  R(ii+1) = sum(data1 .* data2) / OMEGAd;  
end
close all; stem(10+(0:20), R); grid; xlabel('n_2'); ylabel('R[n_1,n_2]'); 
print -dpng fig/korel_roul_sequence.png

% cont 
n1 =10; R = zeros(1,101); 
for ii=0:100,
  n2=n1+ii;  data1 = ksic(:,n1); data2 = ksic(:,n2); 
  R(ii+1) = sum(data1 .* data2) / OMEGAc;  
end
close all; stem(10+(0:100), R); grid; xlabel('n_2'); ylabel('R[n_1,n_2]'); 
print -dpng fig/korel_water_sequence.png

%%%%%%% stacionarita ... 15 different times for each ... 
% disk
sort(floor(rand(1,15) * 1000))
ns = [82   208   257   280   337   425   531   532   546   702   733   749   807   811   966]; 
X = 0:36; x = -5:0.05:40; PXall = zeros(15,37); FXall=zeros(15,length(x)); 
for ii=1:15;
  data = ksid(:,ns(ii)); 
  PX = hist(data,X) / OMEGAd; PXall(ii,:) = PX; 
  FX = cumsum(hist(data,x)) / OMEGAd; FXall(ii,:) = FX; 
end
close all; plot(X,PXall); axis tight; grid; title('P(X_i,n) for many ns'); 
print -dpng fig/all_roul_probas.png
plot(x,FXall); axis tight; grid; title('F(x,n) for many ns'); 
print -dpng fig/all_roul_cumdistribs.png
% all means
allm = mean(ksid); plot(1:1000, allm); print -dpng fig/all_roul_means.png
allvar = var(ksid); plot(1:1000, allvar); print -dpng fig/all_roul_vars.png

% all the corr. coeff sequences ... 
n1s =[10 50 89 106 200 280]; R = zeros(6,21); 
for ii=1:6
  n1 = n1s(ii); 
  for jj=0:20,
    n2=n1+jj;  data1 = ksid(:,n1); data2 = ksid(:,n2); 
    R(ii,jj+1) = sum(data1 .* data2) / OMEGAd;  
  end
end
close all; plot(0:20, R); grid; xlabel('k'); ylabel('R[n_1,n_1+k]'); 
print -dpng fig/all_roul_corrcoeffs.png

% continuous
sort(floor(rand(1,15) * 320))
ns = [    11    24    30    31    48    96   113   141   170   171   223   224   255   294   301]; 
x = linspace(-0.4,0.4,30); delta = x(2) - x(1) 
PXall = zeros(15,length(x)); FXall=zeros(15,length(x)); 
for ii=1:15;
  data = ksic(:,ns(ii)); 
  PX = hist(data,x) / OMEGAc / delta; PXall(ii,:) = PX; 
  FX = cumsum(PX); FXall(ii,:) = FX; 
end
close all; plot(x,PXall); axis tight; grid; title('p(x,n) for many ns'); 
print -dpng fig/all_water_probas.png
plot(x,FXall); axis tight; grid; title('F(x,n) for many ns'); 
print -dpng fig/all_water_cumdistribs.png
% all means
allm = mean(ksic); plot(1:320, allm); print -dpng fig/all_water_means.png
allvar = var(ksic); plot(1:320, allvar); print -dpng fig/all_water_vars.png

% all the corr. coeff sequences ... 
n1s =[10 50 89 106 200 280]; R = zeros(6,51); 
for ii=1:6
  n1 = n1s(ii); 
  for jj=0:50,
    n2=n1+jj;  data1 = ksic(:,n1); data2 = ksic(:,n2); 
    R(ii,jj+1) = sum(data1 .* data2) / OMEGAc;  
  end
end
close all; plot(0:50, R); grid; xlabel('k'); ylabel('R[n_1,n_1+k]'); 
print -dpng fig/all_water_corrcoeffs.png

% oufff ... 

%%%%%%%%%%%%%%%%%% Ergodic estimates %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% taking 10 first measurements as one signal ... 
% disc 
aux = ksid(1:10,:)'; ksi = aux(:); 
% moments 
mean(ksi)
var(ksi) 
   18.0348
   114.4742
% corr coeff 
k=0:20; 
R = xcorr (ksi, 20,'biased'); 
plot (k, R(21:end)); grid; xlabel('k'); ylabel('R[k]'); 
print -dpng fig/ergo_roul_corrcoeffs.png

% continuous ... 
aux = ksic(1:10,:)'; ksi = aux(:); 
% moments 
mean(ksi)
var(ksi) 
   -0.0035
    0.0168

k=0:50; 
R = xcorr (ksi, 50,'biased'); 
plot (k, R(51:end)); grid; xlabel('k'); ylabel('R[k]'); 
print -dpng fig/ergo_water_corrcoeffs.png

%%%%%% try this joint proba ... 
aux = ksid(1:10,:)'; ksi = aux(:); X1 = 0:36; X2 = X1; N = length(ksi); 
k=0; data1 = ksi(1:end-k); data2 = ksi(k+1:end); % shitty Matlab indexing...
P = hist3([data1 data2], {X1 X2}) / N; 
imagesc(X1, X2, P); colorbar; title('P(X_1,X_2,n_1,n_2)');axis xy; 
print -dpng fig/ergo_2d_roul_k_0.png

k=1; data1 = ksi(1:end-k); data2 = ksi(k+1:end); % shitty Matlab indexing...
P = hist3([data1 data2], {X1 X2}) / N; 
imagesc(X1, X2, P); colorbar; title('P(X_1,X_2,n_1,n_2)');axis xy; 
print -dpng fig/ergo_2d_roul_k_1.png

k=3; data1 = ksi(1:end-k); data2 = ksi(k+1:end); % shitty Matlab indexing...
P = hist3([data1 data2], {X1 X2}) / N; 
imagesc(X1, X2, P); colorbar; title('P(X_1,X_2,n_1,n_2)');axis xy; 
print -dpng fig/ergo_2d_roul_k_3.png

%%%%%%%%%%%%%% power spec density - water only %%%%%%%%%%%%%%%%%
aux = ksic(1:10,:)'; ksi = aux(:);
R = xcorr (ksi, 256,'unbiased');
% take only one half and symmetrize ... put zero in hte middle. 
R = R([257:end end-1:-1:258]);  R(257) = 0; plot(R)
% discard one coeff on the left and re-shuffle for DFT ... 
% not good R = R([257:end 1:256]); plot(R) 


G = abs(fft(R));  % should be real and positive  by default, but num. precision sucks
f = (0:256)/512*16000; 
plot (f,G(1:257)); xlabel('f');ylabel('G(f)'); grid; 
print -dpng fig/PSD_from_Rk.png 


%%% by DFT directly from the signal - several ones 
Gsig = zeros(10,129); 
for ii=1:10,
  this = abs(fft(ksic(ii,1:256))).^2 / 256; 
  Gsig(ii,:) = this(1:129);
end
f2 = (0:128)/256*16000; 
plot (f2,Gsig); xlabel('f');ylabel('G(f)'); grid; 
print -dpng fig/PSD_from_sig_bordel.png 

% take avg and compare ... 
plot(f,G(1:257),f2,mean(Gsig)); % not plotting this ... 

plot(f2,mean(Gsig)); xlabel('f');ylabel('G(f)'); grid; 
print -dpng fig/PSD_from_sig_mean.png 

%%%%%%%%%%%%%%%%% white noise %%%%%%%%%%
x = randn(1,1000000); plot(x(1:200)); grid; 
print -dpng fig/white_signal.png 

% doing PSDs ... 
Gsig = zeros(50,129); 
for ii=1:500,
  from = ii*300
  to = ii*300 + 255
  to - from 
  this = abs(fft(x(from:to))).^2 / 256; 
  Gsig(ii,:) = this(1:129);
end
plot (f2,Gsig([1 2 3],:)); xlabel('f');ylabel('G(f)'); grid; 
print -dpng fig/white_PSD_from_sig_bordel.png 
plot (f2,mean(Gsig)); xlabel('f');ylabel('G(f)'); grid; 
print -dpng fig/white_PSD_from_sig_mean.png 










+++++++++++++++++++++++++++

%%%%%%% distrib fce a funkce hust. rozdeleni  pravd. 
% jak vypadaji histaky ? 
legend('F(x,1)','F(x,50)','F(x,100)','F(x,150)'); grid
print -depsc FIG/F_disk.eps

[1/16000 50/16000 100/16000 150/16000]
% to stejne se spoj ... 
legend('F(x,0.1ms)','F(x,3.1ms)','F(x,6.3ms)','F(x,9.4ms)'); grid
print -depsc FIG/F_spoj.eps

%%% ted odhady p(x,t) ... ach jo, to zobrazovani ... 
Delta = x(2) - x(1)
L = 50; myx = [x-Delta/2; x+Delta/2]; myx = myx(:); 
p = H(:,1)/N/Delta; pzobr = [p'; p']; pzobr1 = pzobr(:); 
p = H(:,50)/N/Delta; pzobr = [p'; p']; pzobr50 = pzobr(:); 
p = H(:,100)/N/Delta; pzobr = [p'; p']; pzobr100 = pzobr(:); 
p = H(:,150)/N/Delta; pzobr = [p'; p']; pzobr150 = pzobr(:); 
subplot(221); plot(myx,pzobr1); xlabel('x'); ylabel('p(x,1)');axis tight
subplot(222); plot(myx,pzobr50); xlabel('x'); ylabel('p(x,50)');axis tight
subplot(223); plot(myx,pzobr100); xlabel('x'); ylabel('p(x,100)');axis tight
subplot(224); plot(myx,pzobr150); xlabel('x'); ylabel('p(x,150)');axis tight
print -depsc FIG/p_disk.eps

% jen prejmenovat ... 
subplot(221); plot(myx,pzobr1); xlabel('x'); ylabel('p(x,0.1ms)');axis tight
subplot(222); plot(myx,pzobr50); xlabel('x'); ylabel('p(x,3.1ms)');axis tight
subplot(223); plot(myx,pzobr100); xlabel('x'); ylabel('p(x,6.3ms)');axis tight
subplot(224); plot(myx,pzobr150); xlabel('x'); ylabel('p(x,9.4ms)');axis tight
print -depsc FIG/p_spoj.eps

% souborovy odhad strednich hodnot. 
mens = mean(S); plot (mens)
t = (0:319) * 1/16000; n = 0:319; 
subplot(211); plot(t,mens); grid; xlabel('t'); axis tight;
subplot(212); stem(n,mens); grid; xlabel('n'); axis tight;
print -depsc FIG/means.eps

% ... hm hm, zhruba stac ... 

% smer odchylek ... 
stds = std(S); 
subplot(211); plot(t,stds); grid; xlabel('t'); axis tight; v = axis;
subplot(212); stem(n,stds); grid; xlabel('n'); axis([0 319 v(3) v(4)]); 
print -depsc FIG/stds.eps
% ... hm hm, snad taky ... 


% a ted p(x1,x2,t1,t2) ... to jsou vlastne 2D histogramy, to bude maso !
% zvolime celkovy pocet bodu 10 x 10 = 100, aby se jeste vubec dalo neco 
% pocitat, interval -0.4 do 0.4 
% asi udelam funkci hist2 ... 

% napred zkusime pro cas 1 - 1
x = linspace(-0.4,0.4,30); 
h2 = hist2(S(:,1),S(:,1),x,x); 
imagesc (x,x,h2); axis xy; colorbar
% ... pekny, jen diag. 

% ted pro rozdil 0 az 20 vzorku, ale take pro cas 100 + 0 az 20 !
% pridam take odhad autokor. koeficientu podle teor vztahu 
% 5-8 ze Sebesty (numericka integrace). 
for k = 0:20,
  n1 = 1; n2=n1+k; n3=100; n4=n3+k; 
  [h1,p1,r1] = hist2(S(:,n1),S(:,n2),x,x); 
  [h2,p2,r2] = hist2(S(:,n3),S(:,n4),x,x); 
  %subplot(121); 
  imagesc (x,x,p1); axis xy; colorbar; xlabel('x2'); ylabel('x1');
  name = ['FIG/px1x2_' num2str(k) '.eps']; 
  print (1,'-depsc',name); 
%  subplot(122); imagesc (x,x,p2); axis xy; colorbar
  [k n1 n2 n3 n4 r1 r2]
  pause
end
% cool !!!! 

% compute it for k=0..40 and store somewhere. 
K = 40; 
R1 = zeros(1,K+1); R2 = zeros(1,K+1); 
for k = 0:K,
  n1 = 1; n2=n1+k; n3=100; n4=n3+k; 
  [h1,p1,r1] = hist2(S(:,n1),S(:,n2),x,x); 
  [h2,p2,r2] = hist2(S(:,n3),S(:,n4),x,x); 
  R1(k+1) = r1;   R2(k+1) = r2; k 
end
subplot(211); plot(0:K,R1); xlabel('k'); ylabel('R(0,k)'); grid
subplot(212); plot(0:K,R2); xlabel('k'); ylabel('R(100,100+k)'); grid 
print -depsc FIG/R0R100.eps

% compare with estimates from time domain (use whole signal)

Rtim = xcorr(s,'biased'); 






  